/*  This file is part of the KDE project
    Copyright (C) 2007 Matthias Kretz <kretz@kde.org>

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) version 3.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.

*/

#ifndef PROXYBACKEND_VOLUMEFADEREFFECT_H
#define PROXYBACKEND_VOLUMEFADEREFFECT_H

#include "effect.h"

#include <Phonon/VolumeFaderEffect>
#include <Phonon/VolumeFaderInterface>

namespace Phonon
{
namespace Proxy
{

class VolumeFaderEffect : public Effect, public Phonon::VolumeFaderInterface
{
    Q_OBJECT
    Q_INTERFACES(Phonon::VolumeFaderInterface)
    public:
        VolumeFaderEffect(QObject *parent);
        ~VolumeFaderEffect();

        float volume() const;
        void setVolume(float volume);
        Phonon::VolumeFaderEffect::FadeCurve fadeCurve() const;
        void setFadeCurve(Phonon::VolumeFaderEffect::FadeCurve curve);
        void fadeTo(float volume, int fadeTime);

        QVariant parameterValue(const EffectParameter &p) const;
        void setParameterValue(const EffectParameter &p, const QVariant &newValue);
};

}} //namespace Phonon::Proxy

#endif // PROXYBACKEND_VOLUMEFADEREFFECT_H
